clear all; close all; clc;

% Le modle de la poutre est bas sur l'article de:
% Heiko Panzer, Jorg Hubele, Rudy Eid and Boris Lohmann, "Generating a
% Parametric Finite Element Model of a 3D Cantilever Timoshenko Beam Using
% Matlab"
% Donnes gomtiques du modle de la poutre encastre
L = 15;
t = .5;
h = .5;
% Cration du modle lments finis pour diffrents ordre d'approximation
N       = 75; % H_{900}, discretisation finie
H       = fem_beam(L,t,h,N);
normSys = norm(H);
N_red   = 2;  % H_{24}, discrtisation grossire
H_24    = fem_beam(L,t,h,N_red);
r       = length(H_24.a);
% Rduction de modle utilisant la Toolbox MOR pour obretin Hr_{24}
tic
opt.verbose     = true;
opt.checkROMevo = false;
[Hr_24,o]       = mor.lti(H,r,opt);
time_MOR        = toc;
err_Red_MOR     = norm(H-Hr_24,2)/normSys;
fprintf('** Statistique de la rduction \n')
fprintf('* Erreur en norme H2 : %s \n',err_Red_MOR)
fprintf('* Temps de rduction : %0.5g s \n',time_MOR)
% Simulation d'une rponse impulsionnelle, filtre par F(s) des trois
% modles, H_{900}, H_{24} et Hr_{24}
F    = tf(1e6)*tf(1,[1/1e4 1]);
Tend = 0:1e-2:1; 
fem_beam_plot({H*F,H_24*F,Hr_24*F},{N,N_red,N},Tend,L,t,h)
